local name, private = ...

local dict = private.objects.dict
local L = private.L

private.achievements = dict()

function private.achievements:process()
    -- Process achievement data
    -- Can not process while loading; the item data is not cached at that point.
    
    local a = private.achievements
    
    a["skill journeyman"] = private.objects.data.achievement.skill()
    a["skill journeyman"]:init(4857, 150)
    a["skill expert"] = private.objects.data.achievement.skill()
    a["skill expert"]:init(4919, 225)
    a["skill artisan"] = private.objects.data.achievement.skill()
    a["skill artisan"]:init(4920, 300)
    a["skill master"] = private.objects.data.achievement.skill()
    a["skill master"]:init(4921, 375)
    a["skill grand master"] = private.objects.data.achievement.skill()
    a["skill grand master"]:init(4922, 450)
    a["skill illustrious"] = private.objects.data.achievement.skill()
    a["skill illustrious"]:init(4923, 525)
    a["skill zen"] = private.objects.data.achievement.skill()
    a["skill zen"]:init(6837, 600)
    
    a["rare 1"] = private.objects.data.achievement.rareCount()
    a["rare 1"]:init(4854, 1) -- I Had It in My Hand
    a["rare 10"] = private.objects.data.achievement.rareCount()
    a["rare 10"]:init(4855, 10) -- What was Briefly Yours is Now Mine
    a["rare 20"] = private.objects.data.achievement.rareCount()
    a["rare 20"]:init(4856, 20) -- It Belongs in a Museum
    
    a["common 10"] = private.objects.data.achievement.commonCount()
    a["common 10"]:init(5315, 10) -- Digger
    a["common 50"] = private.objects.data.achievement.commonCount()
    a["common 50"]:init(5469, 50) -- Diggerer
    a["common 100"] = private.objects.data.achievement.commonCount()
    a["common 100"]:init(5470, 100) -- Diggerest
    
    a["race count"] = private.objects.data.achievement.raceCount()
    a["race count"]:init(5511, 9)
    
    -- Seven Scepters
    a["seven scepters"] = private.objects.data.achievement.artifactList()
    a["seven scepters"]:init(4858)
    a["seven scepters"]:addArtifact(1, 64367) -- Scepter of Charlga Razorflank
    a["seven scepters"]:addArtifact(8, 64348) -- Atal'ai Scepter
    a["seven scepters"]:addArtifact(4, 64382) -- Scepter of Xavius
    a["seven scepters"]:addArtifact(6, 64420) -- Scepter of Nekros Skullcrusher
    a["seven scepters"]:addArtifact(2, 64444) -- Scepter of the Nathrezim
    a["seven scepters"]:addArtifact(5, 64475) -- Scepter of Nezar'Azret
    a["seven scepters"]:addArtifact(1, 64487) -- Scepter of Bronzebeard
    
    -- Kings Under the Mountain
    a["kings under the mountain"] = private.objects.data.achievement.artifactList()
    a["kings under the mountain"]:init(4859)
    a["kings under the mountain"]:addArtifact(1, 64368) -- Mithril Chain of Angerforge
    a["kings under the mountain"]:addArtifact(1, 63414) -- Moltenfist's Jeweled Goblet
    a["kings under the mountain"]:addArtifact(1, 64343) -- Winged Helm of Corehammer
    a["kings under the mountain"]:addArtifact(1, 64344) -- Ironstar's Petrified Shield
    a["kings under the mountain"]:addArtifact(1, 64371) -- Skull Staff of Shadowforge
    a["kings under the mountain"]:addArtifact(1, 64485) -- Spiked Gauntlets of Anvilrage
    a["kings under the mountain"]:addArtifact(1, 64484) -- Warmaul of Burningeye
    
    -- Tragedy in Three Acts
    a["tragedy in three acts"] = private.objects.data.achievement.artifactList()
    a["tragedy in three acts"]:init(5191)
    a["tragedy in three acts"]:addArtifact(4, 64357) -- Delicate Music Box
    a["tragedy in three acts"]:addArtifact(4, 63407) -- Cloak Clasp with Antlers
    a["tragedy in three acts"]:addArtifact(4, 64356) -- Hairpin of Silver and Malachite
    a["tragedy in three acts"]:addArtifact(4, 64379) -- Chest of Tiny Glass Animals
    a["tragedy in three acts"]:addArtifact(4, 64381) -- Cracked Crystal Vial
    a["tragedy in three acts"]:addArtifact(4, 64648) -- Silver Scroll Case
    
    -- The Harder They Fall
    a["the harder they fall"] = private.objects.data.achievement.artifactList()
    a["the harder they fall"]:init(5192)
    a["the harder they fall"]:addArtifact(6, 64389) -- Tiny Bronze Scorpion
    a["the harder they fall"]:addArtifact(6, 64417) -- Maul of Stone Guard Mur'og
    a["the harder they fall"]:addArtifact(6, 64418) -- Gray Candle Stub
    a["the harder they fall"]:addArtifact(6, 64419) -- Rusted Steak Knife
    
    -- Blue Streak
    a["blue streak"] = private.objects.data.achievement.artifactList()
    a["blue streak"]:init(5193)
    a["blue streak"]:addArtifact(1, 64337) -- Notched Sword of Tunadil the Redeemer
    a["blue streak"]:addArtifact(1, 64362) -- Dented Shield of Horuz Killcrow
    a["blue streak"]:addArtifact(1, 64366) -- Scorched Staff of Shadow Priest Anund
    a["blue streak"]:addArtifact(1, 64483) -- Silver Kris of Korl
    
    -- The Boy Who Would be King
    a["the boy who would be king"] = private.objects.data.achievement.artifactList()
    a["the boy who would be king"]:init(5301)
    a["the boy who would be king"]:addArtifact(7, 64653) -- Cat Statue with Emerald Eyes
    a["the boy who would be king"]:addArtifact(7, 64654) -- Soapstone Scarab Necklace
    a["the boy who would be king"]:addArtifact(7, 64655) -- Tiny Oasis Mosaic
    a["the boy who would be king"]:addArtifact(7, 64656) -- Engraved Scimitar Hilt
    a["the boy who would be king"]:addArtifact(7, 64658) -- Sketch of a Desert Palace
    a["the boy who would be king"]:addArtifact(7, 64657) -- Canopic Jar
    
    -- The Three Brew Fathers
    a["the three brew fathers"] = private.objects.data.achievement.artifactList()
    a["the three brew fathers"]:init(7331)
    a["the three brew fathers"]:addArtifact(11, 79898) -- Twin Stein Set
    a["the three brew fathers"]:addArtifact(11, 79899) -- Walking Cane
    a["the three brew fathers"]:addArtifact(11, 79900) -- Empty Keg
    
    -- The Broken Hearted
    a["the broken hearted"] = private.objects.data.achievement.artifactList()
    a["the broken hearted"]:init(7332)
    a["the broken hearted"]:addArtifact(11, 79901) -- Carved Bronze Mirror
    a["the broken hearted"]:addArtifact(11, 79902) -- Gold-Inlaid Figurine
    a["the broken hearted"]:addArtifact(11, 79903) -- Apothecary Tins
    
    -- The Four Celestials
    a["the four celestials"] = private.objects.data.achievement.artifactList()
    a["the four celestials"]:init(7333)
    a["the four celestials"]:addArtifact(11, 79904) -- Pearl of Yu'lon
    a["the four celestials"]:addArtifact(11, 79905) -- Standard of Niuzao
    a["the four celestials"]:addArtifact(11, 89684) -- Umbrella of Chi'ji
    a["the four celestials"]:addArtifact(11, 89685) -- Spear of Xuen
    
    -- Instruments of Cruelty
    a["instruments of cruelty"] = private.objects.data.achievement.artifactList()
    a["instruments of cruelty"]:init(7334)
    a["instruments of cruelty"]:addArtifact(12, 79908) -- Manacles of Rebellion
    a["instruments of cruelty"]:addArtifact(12, 79911) -- Petrified Bone Whip
    a["instruments of cruelty"]:addArtifact(12, 79915) -- Warlord's Branding Iron
    a["instruments of cruelty"]:addArtifact(12, 89614) -- Anatomical Dummy
    
    -- Symbols of Strength
    a["symbols of strength"] = private.objects.data.achievement.artifactList()
    a["symbols of strength"]:init(7335)
    a["symbols of strength"]:addArtifact(12, 79914) -- Iron Amulet
    a["symbols of strength"]:addArtifact(12, 79909) -- Cracked Mogu Runestone
    a["symbols of strength"]:addArtifact(12, 79916) -- Mogu Coin
    a["symbols of strength"]:addArtifact(12, 79912) -- Thunder King Insignia
    
    -- Stone Servants
    a["stone servants"] = private.objects.data.achievement.artifactList()
    a["stone servants"]:init(7336)
    a["stone servants"]:addArtifact(12, 79910) -- Terracotta Arm
    a["stone servants"]:addArtifact(12, 89611) -- Quilen Statuette
    
    -- Documents of a Dark History
    a["documents of a dark history"] = private.objects.data.achievement.artifactList()
    a["documents of a dark history"]:init(7337)
    a["documents of a dark history"]:addArtifact(12, 79913) -- Edicts of the Thunder King
    a["documents of a dark history"]:addArtifact(12, 79917) -- Worn Monument Ledger
    
    -- Collector: Pandaren Tea Sets
    a["collector pandaren tea set 5"] = private.objects.data.achievement.artifactCount()
    a["collector pandaren tea set 5"]:init(7338)
    a["collector pandaren tea set 5"]:setArtifact(11, 79896, 5)
    a["collector pandaren tea set 20"] = private.objects.data.achievement.artifactCount()
    a["collector pandaren tea set 20"]:init(7358)
    a["collector pandaren tea set 20"]:setArtifact(11, 79896, 20)
    
    -- Collector: Pandaren Game Boards
    a["collector pandaren game board 5"] = private.objects.data.achievement.artifactCount()
    a["collector pandaren game board 5"]:init(7339)
    a["collector pandaren game board 5"]:setArtifact(11, 79897, 5)
    a["collector pandaren game board 20"] = private.objects.data.achievement.artifactCount()
    a["collector pandaren game board 20"]:init(7359)
    a["collector pandaren game board 20"]:setArtifact(11, 79897, 20)
    
    -- Collector: Twin Stein Sets of Brewfather Quan Tou Kuo
    a["collector twin stein set 5"] = private.objects.data.achievement.artifactCount()
    a["collector twin stein set 5"]:init(7340)
    a["collector twin stein set 5"]:setArtifact(11, 79898, 5)
    a["collector twin stein set 20"] = private.objects.data.achievement.artifactCount()
    a["collector twin stein set 20"]:init(7360)
    a["collector twin stein set 20"]:setArtifact(11, 79898, 20)
    
    -- Collector: Walking Canes of Brewfather Ren Yun
    a["collector walking cane 5"] = private.objects.data.achievement.artifactCount()
    a["collector walking cane 5"]:init(7341)
    a["collector walking cane 5"]:setArtifact(11, 79899, 5)
    a["collector walking cane 20"] = private.objects.data.achievement.artifactCount()
    a["collector walking cane 20"]:init(7361)
    a["collector walking cane 20"]:setArtifact(11, 79899, 20)
    
    -- Collector: Empty Kegs of Brewfather Xin Wo Yin
    a["collector empty keg 5"] = private.objects.data.achievement.artifactCount()
    a["collector empty keg 5"]:init(7342)
    a["collector empty keg 5"]:setArtifact(11, 79900, 5)
    a["collector empty keg 20"] = private.objects.data.achievement.artifactCount()
    a["collector empty keg 20"]:init(7362)
    a["collector empty keg 20"]:setArtifact(11, 79900, 20)
    
    -- Collector: Carved Bronze Mirrors
    a["collector carved bronze mirror 5"] = private.objects.data.achievement.artifactCount()
    a["collector carved bronze mirror 5"]:init(7343)
    a["collector carved bronze mirror 5"]:setArtifact(11, 79901, 5)
    a["collector carved bronze mirror 20"] = private.objects.data.achievement.artifactCount()
    a["collector carved bronze mirror 20"]:init(7363)
    a["collector carved bronze mirror 20"]:setArtifact(11, 79901, 20)
    
    -- Collector: Gold-Inlaid Porcelain Funerary Figurines
    a["collector gold inlaid figurine 5"] = private.objects.data.achievement.artifactCount()
    a["collector gold inlaid figurine 5"]:init(7344)
    a["collector gold inlaid figurine 5"]:setArtifact(11, 79902, 5)
    a["collector gold inlaid figurine 20"] = private.objects.data.achievement.artifactCount()
    a["collector gold inlaid figurine 20"]:init(7364)
    a["collector gold inlaid figurine 20"]:setArtifact(11, 79902, 20)
    
    -- Collector: Apothecary Tins
    a["collector apothecary tins 5"] = private.objects.data.achievement.artifactCount()
    a["collector apothecary tins 5"]:init(7345)
    a["collector apothecary tins 5"]:setArtifact(11, 79903, 5)
    a["collector apothecary tins 20"] = private.objects.data.achievement.artifactCount()
    a["collector apothecary tins 20"]:init(7365)
    a["collector apothecary tins 20"]:setArtifact(11, 79903, 20)
    
    -- Collector: Pearls of Yu'lon
    a["collector pearl of yulon 5"] = private.objects.data.achievement.artifactCount()
    a["collector pearl of yulon 5"]:init(7346)
    a["collector pearl of yulon 5"]:setArtifact(11, 79904, 5)
    a["collector pearl of yulon 20"] = private.objects.data.achievement.artifactCount()
    a["collector pearl of yulon 20"]:init(7366)
    a["collector pearl of yulon 20"]:setArtifact(11, 79904, 20)
    
    -- Collector: Standards of Niuzao
    a["collector standard of niuzao 5"] = private.objects.data.achievement.artifactCount()
    a["collector standard of niuzao 5"]:init(7347)
    a["collector standard of niuzao 5"]:setArtifact(11, 79905, 5)
    a["collector standard of niuzao 20"] = private.objects.data.achievement.artifactCount()
    a["collector standard of niuzao 20"]:init(7367)
    a["collector standard of niuzao 20"]:setArtifact(11, 79905, 20)
    
    -- Collector: Manacles of Rebellion
    a["collector manacles of rebellion 5"] = private.objects.data.achievement.artifactCount()
    a["collector manacles of rebellion 5"]:init(7348)
    a["collector manacles of rebellion 5"]:setArtifact(12, 79908, 5)
    a["collector manacles of rebellion 20"] = private.objects.data.achievement.artifactCount()
    a["collector manacles of rebellion 20"]:init(7368)
    a["collector manacles of rebellion 20"]:setArtifact(12, 79908, 20)
    
    -- Collector: Cracked Mogu Runestones
    a["collector mogu runestone 5"] = private.objects.data.achievement.artifactCount()
    a["collector mogu runestone 5"]:init(7349)
    a["collector mogu runestone 5"]:setArtifact(12, 79909, 5)
    a["collector mogu runestone 20"] = private.objects.data.achievement.artifactCount()
    a["collector mogu runestone 20"]:init(7369)
    a["collector mogu runestone 20"]:setArtifact(12, 79909, 20)
    
    -- Collector: Terracotta Arms
    a["collector terracotta arm 5"] = private.objects.data.achievement.artifactCount()
    a["collector terracotta arm 5"]:init(7350)
    a["collector terracotta arm 5"]:setArtifact(12, 79910, 5)
    a["collector terracotta arm 20"] = private.objects.data.achievement.artifactCount()
    a["collector terracotta arm 20"]:init(7370)
    a["collector terracotta arm 20"]:setArtifact(12, 79910, 20)
    
    -- Collector: Petrified Bone Whips
    a["collector petrified bone whip 5"] = private.objects.data.achievement.artifactCount()
    a["collector petrified bone whip 5"]:init(7351)
    a["collector petrified bone whip 5"]:setArtifact(12, 79911, 5)
    a["collector petrified bone whip 20"] = private.objects.data.achievement.artifactCount()
    a["collector petrified bone whip 20"]:init(7371)
    a["collector petrified bone whip 20"]:setArtifact(12, 79911, 20)
    
    -- Collector: Thunder King Insignias
    a["collector thunder king insignia 5"] = private.objects.data.achievement.artifactCount()
    a["collector thunder king insignia 5"]:init(7352)
    a["collector thunder king insignia 5"]:setArtifact(12, 79912, 5)
    a["collector thunder king insignia 20"] = private.objects.data.achievement.artifactCount()
    a["collector thunder king insignia 20"]:init(7372)
    a["collector thunder king insignia 20"]:setArtifact(12, 79912, 20)
    
    -- Collector: Edicts of the Thunder King
    a["collector edicts of the thunder king 5"] = private.objects.data.achievement.artifactCount()
    a["collector edicts of the thunder king 5"]:init(7353)
    a["collector edicts of the thunder king 5"]:setArtifact(12, 79913, 5)
    a["collector edicts of the thunder king 20"] = private.objects.data.achievement.artifactCount()
    a["collector edicts of the thunder king 20"]:init(7373)
    a["collector edicts of the thunder king 20"]:setArtifact(12, 79913, 20)
    
    -- Collector: Iron Amulets
    a["collector iron amulet 5"] = private.objects.data.achievement.artifactCount()
    a["collector iron amulet 5"]:init(7354)
    a["collector iron amulet 5"]:setArtifact(12, 79914, 5)
    a["collector iron amulet 20"] = private.objects.data.achievement.artifactCount()
    a["collector iron amulet 20"]:init(7374)
    a["collector iron amulet 20"]:setArtifact(12, 79914, 20)
    
    -- Collector: Warlord's Branding Irons
    a["collector warlords branding iron 5"] = private.objects.data.achievement.artifactCount()
    a["collector warlords branding iron 5"]:init(7355)
    a["collector warlords branding iron 5"]:setArtifact(12, 79915, 5)
    a["collector warlords branding iron 20"] = private.objects.data.achievement.artifactCount()
    a["collector warlords branding iron 20"]:init(7375)
    a["collector warlords branding iron 20"]:setArtifact(12, 79915, 20)
    
    -- Collector: Mogu Coins
    a["collector mogu coin 5"] = private.objects.data.achievement.artifactCount()
    a["collector mogu coin 5"]:init(7356)
    a["collector mogu coin 5"]:setArtifact(12, 79916, 5)
    a["collector mogu coin 20"] = private.objects.data.achievement.artifactCount()
    a["collector mogu coin 20"]:init(7376)
    a["collector mogu coin 20"]:setArtifact(12, 79916, 20)
    
    -- Collector: Worn Monument Ledgers
    a["collector worn monument ledger 5"] = private.objects.data.achievement.artifactCount()
    a["collector worn monument ledger 5"]:init(7357)
    a["collector worn monument ledger 5"]:setArtifact(12, 79917, 5)
    a["collector worn monument ledger 20"] = private.objects.data.achievement.artifactCount()
    a["collector worn monument ledger 20"]:init(7377)
    a["collector worn monument ledger 20"]:setArtifact(12, 79917, 20)
    
    -- The Seat of Knowledge
    a["the seat of knowledge"] = private.objects.data.achievement.criteriaList()
    a["the seat of knowledge"]:init(7612)
    a["the seat of knowledge"]:setFirstLine(L("You still need these pristine artifacts:"))
    --a["the seat of knowledge"]:addQuest(31802)
    --a["the seat of knowledge"]:addQuest(31800)
    --a["the seat of knowledge"]:addQuest(31799)
    --a["the seat of knowledge"]:addQuest(31796)
    --a["the seat of knowledge"]:addQuest(31801)
    --a["the seat of knowledge"]:addQuest(31795)
    --a["the seat of knowledge"]:addQuest(31803)
    --a["the seat of knowledge"]:addQuest(31804)
    --a["the seat of knowledge"]:addQuest(31797)
    --a["the seat of knowledge"]:addQuest(31798)
    --a["the seat of knowledge"]:addQuest(31793)
    --a["the seat of knowledge"]:addQuest(31791)
    --a["the seat of knowledge"]:addQuest(31792)
    --a["the seat of knowledge"]:addQuest(31786)
    --a["the seat of knowledge"]:addQuest(31794)
    --a["the seat of knowledge"]:addQuest(31787)
    --a["the seat of knowledge"]:addQuest(31805)
    --a["the seat of knowledge"]:addQuest(31789)
    --a["the seat of knowledge"]:addQuest(31788)
    --a["the seat of knowledge"]:addQuest(31790)
end